#!/bin/sh
#SBATCH --job-name=sec_run
#SBATCH --time=00:10:00
#SBATCH --partition=day
#SBATCH --cpus-per-task=1

#
# Author: Shuwen Deng <shuwen.deng@yale.edu>
# Date:   08.27.2019
#
# This script runs every single assembly test after the simulator is built
#
# This code is released under same license as RocketChip code,
# license details can be found in LICENSE.SiFive file.
#


file_name=$1

echo "is doing " + $1

PATH_RISCV="$RISCV"

cd ../../fpga-zynq/rocket-chip/emulator
ln -fs $PATH_RISCV/riscv64-unknown-elf/share/riscv-tests/isa/rv64ui-v-${file_name:30:-2} output/rv64ui-v-${file_name:30:-2}; ./emulator-freechips.rocketchip.system-DefaultConfig +max-cycles=100000000 output/rv64ui-v-${file_name:30:-2} 2> /dev/null 2> output/rv64ui-v-${file_name:30:-2}.run && [ $PIPESTATUS -eq 0 ]
