#!/bin/sh
#SBATCH --job-name=sec_run
#SBATCH --partition=day
#SBATCH --time=00:10:00
#SBATCH --cpus-per-task=1

#
# Author: Shuwen Deng <shuwen.deng@yale.edu>
# Date:   08.27.2019
#
# This script runs the batch jobs for all the assembly tests 
#
# This code is released under same license as RocketChip code,
# license details can be found in LICENSE.SiFive file.
#
if [ $# -lt 1 ]
then
        echo "Usage: submitall <script> arguments"
        exit 1
fi

script=$1
nset=$2
nway=$3
nsecway=$4
TLB_type=$5
rm emulator/gen_mach/ass_res_tests/*
cd ../../fpga-zynq/rocket-chip/emulator/
make clean
cd ../../../simulation-edits/rocket-chip/
time ./bash_simu.sh ext_miss $nset $nway $nsecway $TLB_type

i=0 
for file in `ls emulator/gen_mach/ass_s_tests/*`
do
  echo "i is $i"
  let i=$i+1
  echo "Submitting: $script for file $file"
  sbatch --array=1-500 --output="emulator/gen_mach/ass_res_tests/${file:30:-2}-%A_%a.out" $script $file > emulator/gen_mach/ass_res_tests/${file:30:-2}-%A_%a.out #$script $file
done
echo "Finished"
