#!/bin/bash

#
# Author: Shuwen Deng <shuwen.deng@yale.edu>
# Date:   08.27.2019
#
# This script builds the set of assembly tests, riscv-tests 
# and rocket chip simulator
#
# This code is released under same license as RocketChip code,
# license details can be found in LICENSE.SiFive file.
#

arg=$0
name=$1
nset=$2
nway=$3
nsecway=$4
TLB_type=$5

cd emulator/gen_mach
rm -rf ass_pre_tests/*.Spre
rm -rf ass_s_tests/*.S
python gen_inst_simu.py $nset\_$nway\_$nsecway  $name
python gen_mach_simu.py $(pwd) 
cp -r ass_s_tests/* ../../riscv-tools/riscv-tests/isa/rv64ui/
cp ass_s_tests/No.1.2_4_8_2_0_0.S ../../riscv-tools/riscv-tests/isa/rv64ui/$name\_$nset\_$nway.S

cd ../../../
if [[ "$TLB_type" == "SA" ]]; then
	cp -r SA_edits/src rocket-chip
elif [[ "$TLB_type" == "SP" ]]; then
	cp -r SP_edits/src rocket-chip
elif [[ "$TLB_type" == "RF" ]]; then
	cp -r RF_edits/src rocket-chip
else
	echo "Wrong TLB type chosen"
	exit 1;	
fi
cp -r rocket-chip ../fpga-zynq/.
cd ../fpga-zynq/rocket-chip/riscv-tools
./test.sh
cd ../emulator
make clean
make output/rv64ui-v-$name\_$nset\_$nway.run
