#
# Author: Shuwen Deng <shuwen.deng@yale.edu>
# Date:   08.27.2019
#
# This file implements the code to generate all the assembly tests 
# for all the TLB vulnerabilities
#
# This code is released under same license as RocketChip code,
# license details can be found in LICENSE.SiFive file.
#

import sys

nset = int((sys.argv[1].split('_'))[0])
nway = int((sys.argv[1].split('_'))[1]) 
nsecway = int((sys.argv[1].split('_'))[2])


""" Global numbers """
sec_page_num = 3
global_inst_count = 1
global_upper_inst_count = 1
MAX_NUM = 1000
test_number = 2
test=0
page_number_of_array = nset*nway + test*nset
whole_set_init = {"enough_whole": 4, "enough_whole_pre_sec": 1, "enough_whole_pre_evict": 
4, "enough_whole_pre": 29, "not_enough_whole": 1, "not_enough_whole_pre_sec": 1, "not_enough_whole_pre_evict": #32
1, "not_enough_whole_pre": 25,
"enough_whole_pre_secway": 29-(nway-nsecway-1)*nset, "not_enough_whole_pre_secway": 25-(nway-nsecway-1)*nset, "enough_whole_pre_insecway": 29, "not_enough_whole_pre_insecway": 25}
whole_set_length = {"enough_whole": nset*(nway-1), "enough_whole_pre_sec": sec_page_num, "enough_whole_pre_evict": nset*(nway-1), "enough_whole_pre": 1, "not_enough_whole": nset*(nway-1), "not_enough_whole_pre_sec": nset*(nway-1), "not_enough_whole_pre_evict": nset*(nway-1), "not_enough_whole_pre": 1,
"enough_whole_pre_secway": 1, "not_enough_whole_pre_secway": 1, "enough_whole_pre_insecway": 1, "not_enough_whole_pre_insecway": 1}
access_pattern = {"1.1": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre",#"enough_whole_pre_evict", 
"rand", "enough_single", "norm", "enough_set", "rand", "enough_single"],
"1.2": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole", "rand", "enough_single", "rand", "enough_single"],
"1.3": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole", "rand", "enough_single", "norm", "enough_set"],
"1.4": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole_pre_evict", 
"rand", "enough_single", "rand", "enough_single"],
"2.1": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre",#"not_enough_whole_pre_evict", 
"rand", "not_enough_single", "rand", "not_enough_set", "rand", "not_enough_single"],
"2.2": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre_evict", 
"rand", "not_enough_whole", "rand", "not_enough_single", "rand", "not_enough_single"],
"2.3": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre_evict", 
"rand", "not_enough_whole", "rand", "not_enough_single", "rand", "not_enough_set"],
"2.4": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole", "rand", "enough_single", "rand", "enough_single"]}
access_secway_pattern = {"1.1": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_secway",#"enough_whole_pre_evict", 
"rand", "enough_single", "norm", "enough_set_secway", "rand", "enough_single"],
"1.2": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole", "rand", "enough_single", "rand", "enough_single"],
"1.3": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_set_secway", "rand", "enough_single", "norm", "enough_set_secway"],
"1.4": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole_pre_evict", 
"rand", "enough_single", "rand", "enough_single"],
"2.1": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre_secway",#"not_enough_whole_pre_evict", 
"rand", "not_enough_single", "rand", "not_enough_set_secway", "rand", "not_enough_single"],
"2.2": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre_evict", 
"rand", "not_enough_whole", "rand", "not_enough_single", "rand", "not_enough_single"],
"2.3": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre_evict", 
"rand", "not_enough_set_secway", "rand", "not_enough_single", "rand", "not_enough_set_secway"],
"2.4": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole", "rand", "enough_single", "rand", "enough_single"]}
access_insecway_pattern = {"1.1": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_insecway",#"enough_whole_pre_evict", 
"rand", "enough_single", "norm", "enough_set_insecway", "rand", "enough_single"],
"1.2": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole", "rand", "enough_single", "rand", "enough_single"],
"1.3": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_set_insecway", "rand", "enough_single", "norm", "enough_set_insecway"],
"1.4": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole_pre_evict", 
"rand", "enough_single", "rand", "enough_single"],
"2.1": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre_insecway",#"not_enough_whole_pre_evict", 
"rand", "not_enough_single", "rand", "not_enough_set_insecway", "rand", "not_enough_single"],
"2.2": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre_evict", 
"rand", "not_enough_whole", "rand", "not_enough_single", "rand", "not_enough_single"],
"2.3": ["norm", "not_enough_whole_pre_sec", "norm", "not_enough_whole_pre_evict", 
"rand", "not_enough_set_insecway", "rand", "not_enough_single", "rand", "not_enough_set_insecway"],
"2.4": ["norm", "enough_whole_pre_sec", "norm", "enough_whole_pre_evict", "norm", "enough_whole", "rand", "enough_single", "rand", "enough_single"]}

variance_category =  ["1.1", "1.2", "1.3", "1.4", "2.1", "2.2", "2.3", "2.4"] 
variance_for_ID = {"1.1": [2, 2], "1.2": [4, 1, 3], "1.3": [4, 1, 3], "1.4": [2, 2], 
                    "2.1": [2, 2], "2.2": [4, 1, 3], "2.3": [4, 1, 3], "2.4": [4, 1, 3] }
access_round_number = {"1.1": [1, 2, 3, 4], "1.2": [2, 3, 4], "1.3": [2, 3, 4], "1.4": [2, 3, 4], 
                    "2.1": [1, 2, 3, 4], "2.2": [2, 3, 4], "2.3": [2, 3, 4], "2.4": [2, 3, 4] }
sec_insec = {"0": "access_secway_pattern", "1": "access_insecway_pattern"}
# first number: total number of variance due to ID; second/third number: the number of step where variance happens

# enough indicates if the TLB is big enough to contain all the secure data
enough_single = []
enough_whole_pre = []
enough_whole_pre_secway = []
enough_whole_pre_insecway = []
enough_set = [[0,0,0,0,0,0,0]]
enough_whole = []
enough_whole_pre_sec = enough_single
enough_whole_pre_evict = []
not_enough_single = []
not_enough_whole_pre = []
not_enough_whole_pre_secway = []
not_enough_whole_pre_insecway = []
not_enough_set = [[0,0,0,0,0,0,0]] 
not_enough_whole = []
not_enough_whole_pre_sec = not_enough_whole
not_enough_whole_pre_evict = []
for i in range(test_number):
  enough_single.append(i+1)
nset_spec = 1
enough_whole_pre.append((nset)*(nway-2) + (nset + nset_spec))
enough_whole_pre_secway.append((nset)*(nway-2) + (nset + nset_spec)-(nway-nsecway-1)*nset)
enough_whole_pre_insecway.append((nset)*(nway-2) + (nset + nset_spec))
for j in range (nway-1+test):
  enough_set[0][j] = (nset)*(j) + (nset + nset_spec)
#[[4, 8, 12, 16, 20, 24, 28], ""[5, 9, 13, 17, 21, 25, 29]"", [6, 10, 14, 18, 22, 26, 30], [7, 11, 15, 19, 23, 27, 31]]
for i in range (nset*(nway-1)):
  enough_whole.append(i+sec_page_num+1)
for i in range (nset*(nway-1)):
  enough_whole_pre_evict.append(i+nset*(nway-1)+sec_page_num+1)

for i in range(test_number):
  not_enough_single.append(i+1+(nway-1)*nset)
nset_spec = 0

not_enough_whole_pre.append((nset)*(nway-2) + (nset_spec + 1))
not_enough_whole_pre_secway.append((nset)*(nway-2) + (nset + nset_spec)-(nway-nsecway-1)*nset)
not_enough_whole_pre_insecway.append((nset)*(nway-2) + (nset + nset_spec))
for j in range (nway-1+test):
  not_enough_set[0][j] = (nset)*(j) + (nset_spec+1)
for i in range (nset*(nway-1)):
  not_enough_whole.append(i+sec_page_num+1)
for i in range (nset*(nway-1)):
  not_enough_whole_pre_evict.append(i+nset*(nway-1)+sec_page_num+4+1)


""" Define pieces of function """
def write_to_file(line, file_pointer):
  file_pointer.write(line)

def key_write_to_file(line, file_pointer):
  global global_inst_count 
  global global_upper_inst_count
  global_inst_count = (global_inst_count + 1)%32
  if global_inst_count==0:
    global_upper_inst_count = (global_upper_inst_count + 1)%32
  file_pointer.write(line)

def find_addr(num):
  return (num)*512

def single_access(addr_num, if_ld, if_enough, if_check, if_norm, file_pointer):
  # addr_num = {1,2,3}, if_enough indicates if the TLB is big enough to contain all the secure data
  # if_norm is true, use ld/stnorm; else, use ld/strand
  # if_ld is true, use ld, else use st
  str_num = str(find_addr(addr_num))
  str_inst = "ld"
  if if_ld == False:
    str_inst = "st" 
  str_type = "rand"
  if if_norm == True:
    str_type = "norm"
  write_to_file("la x7, tdat" + str_num + "\n", file_pointer)
  write_to_file("csrw 0x6,  " + str(global_inst_count) + "\n", file_pointer)
  write_to_file("csrw 0x8,  " + str(global_upper_inst_count) + "\n", file_pointer)
  key_write_to_file(str_inst + str_type + " x6, 0(x7)" + "\n", file_pointer)

def switch_process(process_id, file_pointer):
  write_to_file("\n\ncsrw 0x7, " + str(process_id) + "\n", file_pointer)

def set_access(set_num, if_ld, if_enough, if_check, if_norm, file_pointer, if_secway, process):
  if if_secway:
    if process==1:
      base_num = 1
      if if_enough==True:
        base_num = nset+1
      for i in range(nsecway+test):
        input_num = (nset)*(i) + (set_num+base_num)
        single_access(input_num, if_ld, if_enough, if_check, if_norm, file_pointer)
    elif process==0:
      base_num = 1+(nsecway)*nset
      if if_enough==True:
        base_num = nset+1+(nsecway)*nset
      for i in range(nway-1+test-nsecway):
        input_num = (nset)*(i) + (set_num+base_num)
        single_access(input_num, if_ld, if_enough, if_check, if_norm, file_pointer)
    
  else:
    base_num = 1
    if if_enough==True:
      base_num = nset+1
    for i in range(nway-1+test):
      input_num = (nset)*(i) + (set_num+base_num)
      single_access(input_num, if_ld, if_enough, if_check, if_norm, file_pointer)
      if if_check:
        if (if_enough == False and not_enough_set[set_num].count(input_num)==0) or (if_enough == True and enough_set[set_num].count(input_num)==0):
          print "set element access " + str(input_num) + " is out of bound"

def whole_access(if_ld, set_name, if_check, if_norm, file_pointer, sec_num, sec_num2, current_num, set_num, if_secway, process):
  whole_access_enough = not("not" in set_name)
  if ("single" in set_name):
    if sec_num2 == MAX_NUM and current_num == MAX_NUM:
      if whole_access_enough == True:
        single_access(enough_single[sec_num], if_ld, whole_access_enough, if_check, if_norm, file_pointer)
      elif whole_access_enough == False:
        single_access(not_enough_single[sec_num], if_ld, whole_access_enough, if_check, if_norm, file_pointer)
    else:
      if whole_access_enough == True:
        if current_num == 2 or current_num == 3:
          single_access(enough_single[sec_num], if_ld, whole_access_enough, if_check, if_norm, file_pointer)
        else:
          single_access(enough_single[sec_num2], if_ld, whole_access_enough, if_check, if_norm, file_pointer)
      elif whole_access_enough == False:
        if current_num == 2 or current_num == 3:
          single_access(not_enough_single[sec_num], if_ld, whole_access_enough, if_check, if_norm, file_pointer)
        else:
          single_access(not_enough_single[sec_num2], if_ld, whole_access_enough, if_check, if_norm, file_pointer)
        
    
  elif ("set" in set_name):
    set_access(set_num, if_ld, whole_access_enough, if_check, if_norm, file_pointer, if_secway, process)
  else:
    for i in range(whole_set_length[set_name]):
      input_num = whole_set_init[set_name] + i
      single_access(input_num, if_ld, whole_access_enough, if_check, if_norm, file_pointer)

def pre_text(if_enough, file_pointer):
  write_to_file("#include \"riscv_test.h\"\n", file_pointer)
  write_to_file("#include \"test_macros.h\"\n\n", file_pointer)
  write_to_file("RVTEST_RV64U        # Define TVM used by program.\n\n", file_pointer)
  write_to_file("# Test code region.\n", file_pointer)
  write_to_file("RVTEST_CODE_BEGIN   # Start of test code.\n\n", file_pointer)
  if if_enough == True:
    write_to_file("csrw 0xb, 3\n\n", file_pointer)
    # write_to_file("csrw 0xa, 0\n\n", file_pointer)
    write_to_file("csrw 0xc, 3\n\n", file_pointer)
  elif if_enough == False:
    write_to_file("csrw 0xb, 3\n\n", file_pointer)
    # write_to_file("csrw 0xa, 0\n\n", file_pointer)
    write_to_file("csrw 0xc, 31\n\n", file_pointer)
  write_to_file("csrw 0xa, 0\n\n", file_pointer)
  switch_process(0, file_pointer)
  #write_to_file("", file_pointer)

# for loading the real secure data in the first step
def special_rand(round_num, num_str, file_pointer):
  if (round_num==2 and access_pattern[num_str][2*round_num] == "rand"):#  or (round_num==3 and num_str=="2.1"):
    write_to_file("\ncsrw 0xa, 1\n\n", file_pointer)
  elif round_num==3:
    write_to_file("\ncsrw 0xa, 0\n\n", file_pointer)

def post_text(file_pointer):
  write_to_file("csrw 0x7, 2\n\n", file_pointer)
  write_to_file("\n\n\n\n\n\n\n\n\n\n", file_pointer)
  write_to_file("\n  RVTEST_PASS           # Signal success. \n\n", file_pointer)
  write_to_file("fail:\n", file_pointer)
  write_to_file("    RVTEST_FAIL\n", file_pointer)
  write_to_file("RVTEST_CODE_END     # End of test code.\n\n", file_pointer)
  write_to_file("# Output data section.\n", file_pointer)
  write_to_file("RVTEST_DATA_BEGIN   # Start of test output data region.\n", file_pointer)
  write_to_file("  TEST_DATA\n", file_pointer)
  for y in range(0, 106+page_number_of_array*512): 
    if y%64==0:
      write_to_file("\n", file_pointer)
      write_to_file("tdat0" + str(y/64) + ":\n", file_pointer)
    write_to_file("tdat" + str(y) + ":    .dword " + str(y) + "\n", file_pointer)
  write_to_file("RVTEST_DATA_END     # End of test output data region.\n", file_pointer)

def pre_check(file_pointer):
  write_to_file("\n\ncsrr x10, 0x9\n", file_pointer)

def post_check(file_pointer):
  write_to_file("\n\ncsrr x11, 0x9\n", file_pointer)
  write_to_file("beq x10, x11, fail\n\n", file_pointer)


def generation_by_number(num_str, if_ld, if_check, secway):
  global global_inst_count
  global global_upper_inst_count
  gen_pattern = access_pattern[num_str]
  id_pattern = variance_for_ID[num_str]
  file_num = id_pattern[0] 
  corr_id = {0: [0,0], 1: [0,1], 2: [1, 0], 3: [1,1]}
  big_num = num_str.split(".")[0]
  small_num = num_str.split(".")[1]
  need_more_run_for_two_single_step = (big_num=="1" and (small_num=="2" or small_num=="4")) or (big_num=="2" and (small_num=="2" or small_num=="4"))
  for tmp in range(file_num):
    if file_num==2:
      for sec_num in range(test_number): # sec_page_num):
        range_num = 1 #nset
        for num in range(range_num): 
          global_inst_count = 1
          global_upper_inst_count = 1
          f_in = open("ass_pre_tests/No.%s_%s_%s_%s_%s_%s.Spre" %(num_str, str(nset), str(nway), str(tmp), str(sec_num), str(num)), "wb")
          pre_text(big_num=="1" or (big_num=="2" and small_num=="4"), f_in)
          for i in access_round_number[num_str]:
            special_rand(i, num_str, f_in)
            write_to_file("\n\n", f_in)
            if i in [1,2,3,4]:
              process = 1
              if i == 3 or (i==1 and (num_str=="1.1" or num_str=="2.1")):
                process = tmp
              switch_process(process, f_in)
              write_to_file("\n\n", f_in)
            if i==4:
              pre_check(f_in)
            if secway == True:
              if process == 1:
                gen_pattern = access_secway_pattern[num_str]
              elif process == 0:
                gen_pattern = access_insecway_pattern[num_str]
            if need_more_run_for_two_single_step==True:
              whole_access(if_ld, gen_pattern[2*i+1], if_check, ("norm" in gen_pattern[2*i]), f_in, sec_num, num, i, MAX_NUM, secway, process)
            else:
              whole_access(if_ld, gen_pattern[2*i+1], if_check, ("norm" in gen_pattern[2*i]), f_in, sec_num, MAX_NUM, MAX_NUM, num, secway, process)
          post_check(f_in)
          post_text(f_in)
          f_in.close()


    elif file_num==4:
      for sec_num in range(test_number): # sec_page_num):
        range_num = 1 #nset
        for num in range(range_num):
          global_inst_count = 1
          global_upper_inst_count = 1
          f_in = open("ass_pre_tests/No.%s_%s_%s_%s_%s_%s.Spre" %(num_str, str(nset), str(nway), str(tmp), str(sec_num), str(num)), "wb")
          pre_text(big_num=="1" or (big_num=="2" and small_num=="4"), f_in)
          for i in access_round_number[num_str]:
            special_rand(i, num_str, f_in)
            write_to_file("\n\n", f_in)
            if i ==2:
              process = corr_id[tmp][0]
            elif i == 3:
              process = 1
            elif i == 4:
              process = corr_id[tmp][1]
            switch_process(process, f_in)
            write_to_file("\n\n", f_in)
            if i==4:
              pre_check(f_in)
            if secway == True:
              if process == 1:
                gen_pattern = access_secway_pattern[num_str]
              elif process == 0:
                gen_pattern = access_insecway_pattern[num_str]
            if need_more_run_for_two_single_step==True:
              whole_access(if_ld, gen_pattern[2*i+1], if_check, ("norm" in gen_pattern[2*i]), f_in, sec_num, num, i, MAX_NUM, secway, process)
            else:
              whole_access(if_ld, gen_pattern[2*i+1], if_check, ("norm" in gen_pattern[2*i]), f_in, sec_num, MAX_NUM, MAX_NUM, num, secway, process)
          post_check(f_in)
          post_text(f_in)
          f_in.close()
    

def main(if_ld, if_check):
  for i in range(len(variance_category)):
    generation_by_number(str(variance_category[i]), if_ld, if_check, nsecway != 0)

main(True, True)


