#
# Author: Shuwen Deng <shuwen.deng@yale.edu>
# Date:   08.27.2019
#
# This file implements the code to analyze the simulation results
#
# This code is released under same license as RocketChip code,
# license details can be found in LICENSE.SiFive file.
#

""" verify the result shown in Table 4"""
import sys
import os

dirList = os.listdir(str(sys.argv[1]))

TYP_BEG = 3
TYP_END = 5
ID = 11
IF_MAP = 13
bad_res = 0


typ_proj = {"1.1":0, "1.2": 1, "1.3": 2, "1.4": 3, "2.1": 4, "2.2": 5, "2.3": 6, "2.4": 7}

res_small_cate_match_hit_ori = [[0,0], [0,0,0,0], [0,0,0,0], [0,0], [0,0], [0,0,0,0], [0,0,0,0], [0,0,0,0]]
res_small_cate_not_match_hit_ori = [[0,0], [0,0,0,0], [0,0,0,0], [0,0], [0,0], [0,0,0,0], [0,0,0,0], [0,0,0,0]]
res_small_cate_match_miss_ori = [[0,0], [0,0,0,0], [0,0,0,0], [0,0], [0,0], [0,0,0,0], [0,0,0,0], [0,0,0,0]]
res_small_cate_not_match_miss_ori = [[0,0], [0,0,0,0], [0,0,0,0], [0,0], [0,0], [0,0,0,0], [0,0,0,0], [0,0,0,0]]

res_small_cate_match_hit = [[0,0], [0,0,0,0], [0,0,0,0], [0,0], [0,0], [0,0,0,0], [0,0,0,0], [0,0,0,0]]
res_small_cate_not_match_hit = [[0,0], [0,0,0,0], [0,0,0,0], [0,0], [0,0], [0,0,0,0], [0,0,0,0], [0,0,0,0]]
res_small_cate_match_miss = [[0,0], [0,0,0,0], [0,0,0,0], [0,0], [0,0], [0,0,0,0], [0,0,0,0], [0,0,0,0]]
res_small_cate_not_match_miss = [[0,0], [0,0,0,0], [0,0,0,0], [0,0], [0,0], [0,0,0,0], [0,0,0,0], [0,0,0,0]]

res_sum_match_hit=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
res_sum_not_match_hit=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
res_sum_match_miss=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
res_sum_not_match_miss=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]


def process_line(line, type, if_map, id, file, check):
	global bad_res
	if line.startswith('slurmstepd: error: ***'):
		if check:
			if if_map:
				res_small_cate_match_hit_ori[type][int(id)] = res_small_cate_match_hit_ori[type][int(id)] + 1
			else:
				res_small_cate_not_match_hit_ori[type][int(id)] = res_small_cate_not_match_hit_ori[type][int(id)] + 1
	elif line.startswith('Listening'):
		if check:
			if if_map:
				res_small_cate_match_miss_ori[type][int(id)] = res_small_cate_match_miss_ori[type][int(id)] + 1
			else:
				res_small_cate_not_match_miss_ori[type][int(id)] = res_small_cate_not_match_miss_ori[type][int(id)] + 1
	elif line.endswith('is up to date.\n') or line.startswith('make: ***') or line.startswith('ln -fs /home/fas'):
		if check:
			bad_res = bad_res + 1
	else:
		print("Unrecognized line: %s" %(line))
		print file


def switch():


	res_small_cate_match_hit[0][0] = res_small_cate_match_hit_ori[1][1]
	res_small_cate_match_hit[0][1] = res_small_cate_match_hit_ori[1][3]
	res_small_cate_match_hit[1][0] = res_small_cate_match_hit_ori[5][1]
	res_small_cate_match_hit[1][1] = res_small_cate_match_hit_ori[5][3]
	res_small_cate_match_hit[1][2] = res_small_cate_match_hit_ori[7][1]
	res_small_cate_match_hit[1][3] = res_small_cate_match_hit_ori[7][3]
	res_small_cate_match_hit[2][0] = res_small_cate_match_hit_ori[1][0]
	res_small_cate_match_hit[2][1] = res_small_cate_match_hit_ori[1][2]
	res_small_cate_match_hit[2][2] = res_small_cate_match_hit_ori[5][0]
	res_small_cate_match_hit[2][3] = res_small_cate_match_hit_ori[5][2]
	res_small_cate_match_hit[3][0] = res_small_cate_match_hit_ori[7][0]
	res_small_cate_match_hit[3][1] = res_small_cate_match_hit_ori[7][2]
	res_small_cate_match_hit[4][0] = res_small_cate_match_hit_ori[0][0]
	res_small_cate_match_hit[4][1] = res_small_cate_match_hit_ori[4][0]
	res_small_cate_match_hit[5][0] = res_small_cate_match_hit_ori[2][0]
	res_small_cate_match_hit[5][1] = res_small_cate_match_hit_ori[6][0]
	res_small_cate_match_hit[5][2] = res_small_cate_match_hit_ori[4][1]
	res_small_cate_match_hit[5][3] = res_small_cate_match_hit_ori[0][1]
	res_small_cate_match_hit[6][0] = res_small_cate_match_hit_ori[2][3]
	res_small_cate_match_hit[6][1] = res_small_cate_match_hit_ori[6][3]
	res_small_cate_match_hit[6][2] = res_small_cate_match_hit_ori[2][2]
	res_small_cate_match_hit[6][3] = res_small_cate_match_hit_ori[6][2]
	res_small_cate_match_hit[7][0] = res_small_cate_match_hit_ori[2][1]
	res_small_cate_match_hit[7][1] = res_small_cate_match_hit_ori[6][1]

	res_small_cate_not_match_hit[0][0] = res_small_cate_not_match_hit_ori[1][1]
	res_small_cate_not_match_hit[0][1] = res_small_cate_not_match_hit_ori[1][3]
	res_small_cate_not_match_hit[1][0] = res_small_cate_not_match_hit_ori[5][1]
	res_small_cate_not_match_hit[1][1] = res_small_cate_not_match_hit_ori[5][3]
	res_small_cate_not_match_hit[1][2] = res_small_cate_not_match_hit_ori[7][1]
	res_small_cate_not_match_hit[1][3] = res_small_cate_not_match_hit_ori[7][3]
	res_small_cate_not_match_hit[2][0] = res_small_cate_not_match_hit_ori[1][0]
	res_small_cate_not_match_hit[2][1] = res_small_cate_not_match_hit_ori[1][2]
	res_small_cate_not_match_hit[2][2] = res_small_cate_not_match_hit_ori[5][0]
	res_small_cate_not_match_hit[2][3] = res_small_cate_not_match_hit_ori[5][2]
	res_small_cate_not_match_hit[3][0] = res_small_cate_not_match_hit_ori[7][0]
	res_small_cate_not_match_hit[3][1] = res_small_cate_not_match_hit_ori[7][2]
	res_small_cate_not_match_hit[4][0] = res_small_cate_not_match_hit_ori[0][0]
	res_small_cate_not_match_hit[4][1] = res_small_cate_not_match_hit_ori[4][0]
	res_small_cate_not_match_hit[5][0] = res_small_cate_not_match_hit_ori[2][0]
	res_small_cate_not_match_hit[5][1] = res_small_cate_not_match_hit_ori[6][0]
	res_small_cate_not_match_hit[5][2] = res_small_cate_not_match_hit_ori[4][1]
	res_small_cate_not_match_hit[5][3] = res_small_cate_not_match_hit_ori[0][1]
	res_small_cate_not_match_hit[6][0] = res_small_cate_not_match_hit_ori[2][3]
	res_small_cate_not_match_hit[6][1] = res_small_cate_not_match_hit_ori[6][3]
	res_small_cate_not_match_hit[6][2] = res_small_cate_not_match_hit_ori[2][2]
	res_small_cate_not_match_hit[6][3] = res_small_cate_not_match_hit_ori[6][2]
	res_small_cate_not_match_hit[7][0] = res_small_cate_not_match_hit_ori[2][1]
	res_small_cate_not_match_hit[7][1] = res_small_cate_not_match_hit_ori[6][1]

	res_small_cate_not_match_miss[0][0] = res_small_cate_not_match_miss_ori[1][1]
	res_small_cate_not_match_miss[0][1] = res_small_cate_not_match_miss_ori[1][3]
	res_small_cate_not_match_miss[1][0] = res_small_cate_not_match_miss_ori[5][1]
	res_small_cate_not_match_miss[1][1] = res_small_cate_not_match_miss_ori[5][3]
	res_small_cate_not_match_miss[1][2] = res_small_cate_not_match_miss_ori[7][1]
	res_small_cate_not_match_miss[1][3] = res_small_cate_not_match_miss_ori[7][3]
	res_small_cate_not_match_miss[2][0] = res_small_cate_not_match_miss_ori[1][0]
	res_small_cate_not_match_miss[2][1] = res_small_cate_not_match_miss_ori[1][2]
	res_small_cate_not_match_miss[2][2] = res_small_cate_not_match_miss_ori[5][0]
	res_small_cate_not_match_miss[2][3] = res_small_cate_not_match_miss_ori[5][2]
	res_small_cate_not_match_miss[3][0] = res_small_cate_not_match_miss_ori[7][0]
	res_small_cate_not_match_miss[3][1] = res_small_cate_not_match_miss_ori[7][2]
	res_small_cate_not_match_miss[4][0] = res_small_cate_not_match_miss_ori[0][0]
	res_small_cate_not_match_miss[4][1] = res_small_cate_not_match_miss_ori[4][0]
	res_small_cate_not_match_miss[5][0] = res_small_cate_not_match_miss_ori[2][0]
	res_small_cate_not_match_miss[5][1] = res_small_cate_not_match_miss_ori[6][0]
	res_small_cate_not_match_miss[5][2] = res_small_cate_not_match_miss_ori[4][1]
	res_small_cate_not_match_miss[5][3] = res_small_cate_not_match_miss_ori[0][1]
	res_small_cate_not_match_miss[6][0] = res_small_cate_not_match_miss_ori[2][3]
	res_small_cate_not_match_miss[6][1] = res_small_cate_not_match_miss_ori[6][3]
	res_small_cate_not_match_miss[6][2] = res_small_cate_not_match_miss_ori[2][2]
	res_small_cate_not_match_miss[6][3] = res_small_cate_not_match_miss_ori[6][2]
	res_small_cate_not_match_miss[7][0] = res_small_cate_not_match_miss_ori[2][1]
	res_small_cate_not_match_miss[7][1] = res_small_cate_not_match_miss_ori[6][1]

	res_small_cate_match_miss[0][0] = res_small_cate_match_miss_ori[1][1]
	res_small_cate_match_miss[0][1] = res_small_cate_match_miss_ori[1][3]
	res_small_cate_match_miss[1][0] = res_small_cate_match_miss_ori[5][1]
	res_small_cate_match_miss[1][1] = res_small_cate_match_miss_ori[5][3]
	res_small_cate_match_miss[1][2] = res_small_cate_match_miss_ori[7][1]
	res_small_cate_match_miss[1][3] = res_small_cate_match_miss_ori[7][3]
	res_small_cate_match_miss[2][0] = res_small_cate_match_miss_ori[1][0]
	res_small_cate_match_miss[2][1] = res_small_cate_match_miss_ori[1][2]
	res_small_cate_match_miss[2][2] = res_small_cate_match_miss_ori[5][0]
	res_small_cate_match_miss[2][3] = res_small_cate_match_miss_ori[5][2]
	res_small_cate_match_miss[3][0] = res_small_cate_match_miss_ori[7][0]
	res_small_cate_match_miss[3][1] = res_small_cate_match_miss_ori[7][2]
	res_small_cate_match_miss[4][0] = res_small_cate_match_miss_ori[0][0]
	res_small_cate_match_miss[4][1] = res_small_cate_match_miss_ori[4][0]
	res_small_cate_match_miss[5][0] = res_small_cate_match_miss_ori[2][0]
	res_small_cate_match_miss[5][1] = res_small_cate_match_miss_ori[6][0]
	res_small_cate_match_miss[5][2] = res_small_cate_match_miss_ori[4][1]
	res_small_cate_match_miss[5][3] = res_small_cate_match_miss_ori[0][1]
	res_small_cate_match_miss[6][0] = res_small_cate_match_miss_ori[2][3]
	res_small_cate_match_miss[6][1] = res_small_cate_match_miss_ori[6][3]
	res_small_cate_match_miss[6][2] = res_small_cate_match_miss_ori[2][2]
	res_small_cate_match_miss[6][3] = res_small_cate_match_miss_ori[6][2]
	res_small_cate_match_miss[7][0] = res_small_cate_match_miss_ori[2][1]
	res_small_cate_match_miss[7][1] = res_small_cate_match_miss_ori[6][1]




for file in dirList:
	# print file
	f_in = open(str(sys.argv[1]) + "/" + file,  "rb")
	last_line = f_in.readlines()[-1]
	process_line(last_line, typ_proj[file[TYP_BEG:TYP_END+1]], file[IF_MAP]=='0', file[ID], file, True)
	f_in.close()
	
switch()


for i in range(2):
	res_sum_match_hit[i]=res_small_cate_match_hit[0][i]
	res_sum_not_match_hit[i]=res_small_cate_not_match_hit[0][i]
	res_sum_match_miss[i]=res_small_cate_match_miss[0][i]
	res_sum_not_match_miss[i]=res_small_cate_not_match_miss[0][i]

for i in range(4):
	res_sum_match_hit[2+i]=res_small_cate_match_hit[1][i]
	res_sum_not_match_hit[2+i]=res_small_cate_not_match_hit[1][i]
	res_sum_match_miss[2+i]=res_small_cate_match_miss[1][i]
	res_sum_not_match_miss[2+i]=res_small_cate_not_match_miss[1][i]

for i in range(4):
	res_sum_match_hit[6+i]=res_small_cate_match_hit[2][i]
	res_sum_not_match_hit[6+i]=res_small_cate_not_match_hit[2][i]
	res_sum_match_miss[6+i]=res_small_cate_match_miss[2][i]
	res_sum_not_match_miss[6+i]=res_small_cate_not_match_miss[2][i]

for i in range(2):
	res_sum_match_hit[10+i]=res_small_cate_match_hit[3][i]
	res_sum_not_match_hit[10+i]=res_small_cate_not_match_hit[3][i]
	res_sum_match_miss[10+i]=res_small_cate_match_miss[3][i]
	res_sum_not_match_miss[10+i]=res_small_cate_not_match_miss[3][i]

for i in range(2):
	res_sum_match_hit[12+i]=res_small_cate_match_hit[4][i]
	res_sum_not_match_hit[12+i]=res_small_cate_not_match_hit[4][i]
	res_sum_match_miss[12+i]=res_small_cate_match_miss[4][i]
	res_sum_not_match_miss[12+i]=res_small_cate_not_match_miss[4][i]

for i in range(4):
	res_sum_match_hit[14+i]=res_small_cate_match_hit[5][i]
	res_sum_not_match_hit[14+i]=res_small_cate_not_match_hit[5][i]
	res_sum_match_miss[14+i]=res_small_cate_match_miss[5][i]
	res_sum_not_match_miss[14+i]=res_small_cate_not_match_miss[5][i]

for i in range(4):
	res_sum_match_hit[18+i]=res_small_cate_match_hit[6][i]
	res_sum_not_match_hit[18+i]=res_small_cate_not_match_hit[6][i]
	res_sum_match_miss[18+i]=res_small_cate_match_miss[6][i]
	res_sum_not_match_miss[18+i]=res_small_cate_not_match_miss[6][i]

for i in range(2):
	res_sum_match_hit[22+i]=res_small_cate_match_hit[7][i]
	res_sum_not_match_hit[22+i]=res_small_cate_not_match_hit[7][i]
	res_sum_match_miss[22+i]=res_small_cate_match_miss[7][i]
	res_sum_not_match_miss[22+i]=res_small_cate_not_match_miss[7][i]

print "=========================================================================================================================="

print "Miss number for mapped: ",
print res_sum_match_miss # res_small_cate_match_miss # res_sum_match_miss
print "Miss number for not-mapped: ",
print res_sum_not_match_miss # res_small_cate_not_match_miss # res_sum_not_match_miss


print "Hit number for mapped: ",
print res_sum_match_hit #res_small_cate_match_hit # res_sum_match_hit
print "Hit number for not-mapped: ",
print res_sum_not_match_hit #res_small_cate_not_match_hit # res_sum_not_match_hit

print "\n===================================="
print "There are %d insuccessful simulations" %(bad_res) 
print "=========================================================================================================================="


