#!/bin/sh

#
# Author: Shuwen Deng <shuwen.deng@yale.edu>
# Date:   08.27.2019
#
# This script runs the single test of an assembly
#
# This code is released under same license as RocketChip code,
# license details can be found in LICENSE.SiFive file.
#

if [ $# -lt 1 ]
then
        echo "Usage: submitall <script> arguments"
        exit 1
fi

file_name=$1
nset=$2
nway=$3
nsecway=$4
TLB_type=$5
rm emulator/gen_mach/ass_res_tests/*
cd ../../fpga-zynq/rocket-chip/emulator/
make clean
cd ../../../simulation-edits/rocket-chip/
time ./bash_simu.sh ext_miss $nset $nway $nsecway $TLB_type

echo "is doing " + $file_name
PATH_RISCV="$RISCV"
cd ../../fpga-zynq/rocket-chip/emulator
ln -fs $PATH_RISCV/riscv64-unknown-elf/share/riscv-tests/isa/rv64ui-v-${file_name:30:-2} output/rv64ui-v-${file_name:30:-2}; ./emulator-freechips.rocketchip.system-DefaultConfig +max-cycles=100000000 output/rv64ui-v-${file_name:30:-2} 2> /dev/null 2> output/rv64ui-v-${file_name:30:-2}.run && [ $PIPESTATUS -eq 0 ]


